var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var results_exports = {};
__export(results_exports, {
  default: () => results_default
});
module.exports = __toCommonJS(results_exports);
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_utils = require("../utils.js");
let resultField = (field, node) => import_futil.default.cascade([`response.${field}`, field], node.context);
var results_default = async ({ service, tree, ...node }) => {
  let { page = 1, pageSize = 100 } = node;
  let run = (props) => (0, import_utils.runWith)(
    service,
    tree,
    import_futil.default.omitNil({
      key: "results",
      type: "results",
      ...node,
      ...props
    })
  );
  let scrollId;
  let totalRecords = resultField(
    "totalRecords",
    await run({ pageSize: 1, page: 1 })
  );
  let results = {
    getTotalRecords() {
      return totalRecords;
    },
    async *[Symbol.asyncIterator]() {
      let next = run({ page, scrollId, skipCount: true });
      while (page <= Math.ceil(totalRecords / pageSize)) {
        let cNode = results.node = await next;
        scrollId = cNode.context.scrollId;
        next = run({ page: page + 1, scrollId, skipCount: true });
        page++;
        for (let r of import_fp.default.map(
          (0, import_utils.flattenProp)("_source"),
          resultField("results", cNode)
        ))
          yield r;
      }
    }
  };
  return results;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
