var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var terms_stats_exports = {};
__export(terms_stats_exports, {
  default: () => terms_stats_default
});
module.exports = __toCommonJS(terms_stats_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_utils = require("../utils.js");
var terms_stats_default = async ({ service, tree, ...node }) => {
  let { key_field, size = 100 } = node;
  let run = (node2) => (0, import_utils.runWith)(service, tree, node2);
  let totalRecords = import_fp.default.get(
    "context.value",
    await run({
      key: "cardinality",
      type: "cardinality",
      field: key_field,
      fieldMode: "autocomplete"
    })
  );
  let terms_stats = {
    getTotalRecords() {
      return totalRecords;
    },
    async *[Symbol.asyncIterator]() {
      let cNode = terms_stats.node = await run({
        ...node,
        key: "stats",
        type: "terms_stats",
        key_field,
        size: size || totalRecords
      });
      for (let t of import_fp.default.getOr([], "context.terms", cNode))
        yield t;
    }
  };
  return terms_stats;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
