var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  andGroup: () => andGroup,
  flattenProp: () => flattenProp,
  runWith: () => runWith,
  setFilterOnly: () => setFilterOnly
});
module.exports = __toCommonJS(utils_exports);
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
let Tree = import_futil.default.tree((x) => x.children);
let setFilterOnly = Tree.transform((x) => {
  x.filterOnly = true;
});
let andGroup = (...args) => {
  let children = import_fp.default.flatten(args);
  let [{ schema, key }] = children;
  return { key: `${key}-parent`, type: "group", join: "and", schema, children };
};
let lastChild = import_fp.default.flow(import_fp.default.get("children"), import_fp.default.last);
let runWith = async (service, tree, node) => lastChild(await service(andGroup(setFilterOnly(tree), node)));
let flattenProp = import_fp.default.curry(
  (prop, target) => import_fp.default.flow(import_futil.default.expandObject(import_fp.default.get(prop)), import_fp.default.unset(prop))(target)
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  andGroup,
  flattenProp,
  runWith,
  setFilterOnly
});
